<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <title>Eclipse TGcrud Bindings Overview</title>

        <style type="text/css">
            .TODO {
                padding-left: 10pt;
                background-color: #ffffaa;
                color: black;
                border: 1px solid #ddddff;
                border-left: 5pt solid blue;
            }
            .TODO:before {
                content: "TODO ";
                font-weight: bold;
                color: blue;
            }
            .important {
                border-left: 5pt solid red;
                padding-left: 10pt;
            }
            .pseudocode {
                 
                font-family: serif;
                font-style: italic;
                font-size: inherit;
                color: darkblue;
                list-style: none;
            }
        </style>
    </head>
    <body>
        <h1>Basic Architecture</h1>
        <p>TGcrud offers a rather different interface for saving information
            than Eclipse: Eclipse's storage system is based on a workspace
            containing named projects containing named files and folders, rather
            oriented on traditional file systems. TGcrud, however, maintains a
            set of objects described by a set of metadata (like authors, title
            etc.). Both can use <abbr title="Uniform Resource Identifier">URI</abbr>s to identify files.</p>
        <p>The plugins info.textgrid.lab.core.model and info.textgrid.lab.core.efs.tgcrud try to bridge the 
        	gap between both systems and to offer
            a convenient way for TextGridLab plugins to access both
            TextGridRep's objects and metadata.</p>
        <h2>Three implementation layers</h2>
        <p>
            <object class="image" width="490" height="367" style="float: right;" type="image/svg+xml" data="layers.svg">
            	<img src="layers.png" alt="TextGrid ↔ TGCrud has three implementation layers"/>
            </object>
        </p>
        <p> We use three implementation layers to manage our objects:</p>
        <ul>
            <li>The <strong class="term">model layer</strong> represents
                TextGridRep's objects using their metadata, in
                    <code><a href="../../javadoc/info/textgrid/lab/core/model/TextGridObject.html">TextGridObject</a></code>s. This layer is completely
                implemented by TextGrid, and it is the layer clients like object
                browsers or metadata editors usually talk with and which
                commands and menu entries on TextGrid objects are usually
                contributed to.</li>
            <li>The <strong class="term">resource layer</strong> containing
                    <code>IFile</code>s, <code>IProject</code>s and other
                    <code>IResource</code>s is the layer (content) editors
                usually see. It is the standard way of interacting with files in
                Eclipse, and it is completely implemented by Eclipse. </li>
            <li>The <strong class="term">EFS layer</strong> contains the backend
                that performs the actual reading and writing. It is implemented
                by TextGrid extending an interface defined by Eclipse, and
                clients usually don't interact directly with this interface
            </li>
        </ul>
        <h2>Conversion</h2>
        <p>Conversion between the layers works by using the adaptor pattern as
            provided by Eclipse. I.E., if you have a <a href="../../javadoc/info/textgrid/lab/core/model/TextGridObject.html">TextGridObject</a> and need an
            IFile,</p>
        <pre>
                <a href="../../javadoc/info/textgrid/lab/core/model/TextGridObject.html">TextGridObject</a> textGridObject;
                /* ... fill textGridObject ... */
                IFile file = (IFile) textGridObject.getAdapter(IFile.class);
                if (file != null) 
                  /* do something with file */
        </pre>
        <p>or vice versa</p>
        <pre>
                IFile file; 
                /* ... fill file ... */
                <a href="../../javadoc/info/textgrid/lab/core/model/TextGridObject.html">TextGridObject</a> textGridObject = (TextGridObject) file.getAdaptor(TextGridObject.class);
        </pre>
        <h2>Tasks</h2>
        <p class="important"> Everything in this section is subject to change /
            refactoring. Please always check with the implementation, and please
            always see the javadocs (which may be more detailed, anyway).</p>

        <h3>Getting a TextGridObject</h3>
        <h4>From a TextGrid URI</h4>
        <pre>
            URI uri; 
            /* get the object's URI somehow into <var>uri</var> */
            TextGridObject object = TextGridObject.getInstance(uri, true);
        </pre>
        <p>This creates a new TextGridObject from a textgrid uri, calling
            TGcrud#readMetadata if neccessary. If you set the last argument
            to <code>false</code>, the call to readMetadata may be delayed.</p>
        <h4>From a Metadata blob</h4>
        <p>You need to pass in the metadata as an XML tree fragment hanging from
            an OMElement (that's AXIOMs element representation). The OMElement
            should contain the tgMetadataObject.</p>
        <pre>
            OMElement element;
            boolean complete;	// if false, element contains only fragmentary metadata
            /* get some metadata into element */
            TextGridObject object = TextGridObject.getInstance(element, complete);
        </pre>
        
        <p>If you create a TextGridObject from an XML fragment, there will be
        no immediate network access. This is especially useful if you create a lot
        of TextGridObjects at once (think search) and do not want a web service
        call for every single one. With the last argument (<var>complete</var>), you
        determine whether the metadata fragment you pass in is complete, i.e. it 
        contains all the metadata TextGrid knows about for this TextGridRep object.
        If you specify false here and access a field not present in the metadata
        fragment at a later point in time, the object is finally completed by
        a call to TGcrud's readMetadata operation.</p>   

        <h3>Representing TextGridObjects</h3>

        <p> If your plugin somehow represents / contains a bunch of TextGrid
            objects (e.g. search results or object browser), your objects (the
            stuff you put in your StructuredSelections and/or that your
            ContentProvider provides) must adapt to TextGridObjects (and they
            should adapt to IFile, as well; once they have a TextGridObject
                <var>tgo</var> they do so by forwarding the adaption request to
            TextGridObject, i.e. <code>return
            tgo.getAdaptor(IFile.class)</code>). </p>
        <p>Either your objects are PlatformObjects or IAdaptables and you
            provide an adaptor factory, or you simply put the TextGridObjects
            themselves in your selection/viewer.</p>

        <h3>Contributing stuff to TextGridObjects</h3>
        <p class="TODO">See info.textgrid.lab.ui.core for an example </p>

        <h1>Implementation</h1>
        <p>There are <a href="devel-notes.html">implementation notes in a separate document</a></p>
    </body>
</html>
